/*

* Copyright (c) 2006, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions 
* are met:
*
*   * Redistributions of source code must retain the above copyright notice, 
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its 
*     contributors may be used to endorse or promote products derived from 
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
* POSSIBILITY OF SUCH DAMAGE.
*
*/

import java.util.*;

public class EDMethod {
	
	static final byte PATTERN = 0x01;
	static final byte HORIZON = 0x02;
	static final byte SLOPE = 0x03;
	static final byte OSCILLATION = 0x04;
	static final byte JUMP = 0x05;
	static final byte SPIKE = 0x06;
	byte type;  // type of the method	
	
	static final byte I = 0x01;
	static final byte D = 0x02;
	byte mode;  // change mode of the method
	
	int id;  // id of the method
	
	String name;  // system-assigned name of the method
		
	String attribute;  // 1st input parameter of the method		
	String configFile;  // 2nd input paramter of the method	
	
	Query q;  // query that the method is embedded in
	
	boolean returnVal;
	long returnTimestamp;  // timestamp corresponding to current method return value	
	
	int sp;  // sample period (unit: second)
	int T;  // interval of inspection (unit: second)
	int n;  // lenght of the historical reading sequence (n = T/sp + 1)
	int span;  // span of the method
	double one_minus_alpha;  // confidence level
	double epsilon;  // error bound
	
	long lastTimeofMatching = 0;  // for horizon, slope and oscillation patterns only
	double mean = -1;  // for horizon and oscillation patterns only		
	
}  // class EDMethod