/*

* Copyright (c) 2006, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions 
* are met:
*
*   * Redistributions of source code must retain the above copyright notice, 
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its 
*     contributors may be used to endorse or promote products derived from 
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
* POSSIBILITY OF SUCH DAMAGE.
*
*/

public class HorizonMethod extends EDMethod  {
	
	HorizonMethod (Query q) 
	  {
	  	type = EDMethod.HORIZON; 
	  	
	  	this.q = q;
	  	
	  	returnVal = false; 
	  	returnTimestamp = System.currentTimeMillis();
	  }	
	  
	public HorizonMethod copy()
	  {
	  	HorizonMethod M = new HorizonMethod(q);
	  	
	  	M.type = this.type;
	  	M.mode = this.mode;
	  	M.id = this.id;
	  	M.name = this.name;
	  	M.attribute = this.attribute;
	  	M.configFile = this.configFile;
	  	M.q = this.q;
	  	M.returnTimestamp = this.returnTimestamp;
	  	M.returnVal = this.returnVal;
	  	M.sp = this.sp;  M.T = this.T;  M.n = this.n;
        M.span = this.span;  M.one_minus_alpha = this.one_minus_alpha; M.epsilon = this.epsilon;
        M.lastTimeofMatching=this.lastTimeofMatching;  M.mean = this.mean;
        
        return M;	  	
	  }
	
}  // class HorizonMethod